function DOMtoString() {
    var imgs = document.getElementsByTagName("img");
    var images = [];
    for (var i = 0; i < imgs.length; i++) {
        var img = imgs[i];
        if (img.width < 50 || img.height < 50) {
            continue;
        }

        var src = img.src;
        var width = img.naturalWidth;
        var height = img.naturalHeight;
        var urlConverted = false;

        if (img.currentSrc && img.currentSrc !== img.src) {
            src = img.currentSrc;
        }

        if (/\S+[.]pinimg[.]com/.test(src)) {
            if (typeof img.srcset === 'string') {
                var srcs = img.srcset.split(",");
                var s = srcs[srcs.length - 1].replace(/[0-9]+x/g, "").trim();
                if (/\S+[.]pinimg[.]com/.test(s)) {
                    src = s;
                    urlConverted = true;
                }
            }
        }

        // Huaban 补强
        var customTitle;
        if (location.href.indexOf("huaban.com") > -1) {
            var $pin = jQuery(".pin").has(img);
            if ($pin.length > 0) {
                var description = $pin.find("p.description").attr("data-formatted");
                if (description && description.length > 0) {
                    customTitle = description.trim();
                }
            }
        }

        var img = {
            width: width,
            height: height,
            src: src,
            title: customTitle || img.alt || img.title
        };

        if (urlConverted) {
            img.urlConverted = true;
        }
        
        images.push(img);
    }
    var bgs = getBackgroundImages();
    bgs.forEach(function(bg) {
        images.push(bg);
    });

    // images.sort(function(a, b) {
    //     return (b.width * b.height) - (a.width * a.height);
    // });
    return images;
}

function getStyle(x, styleProp) {
    if (x.currentStyle) var y = x.currentStyle[styleProp];
    else if (window.getComputedStyle) var y = document.defaultView.getComputedStyle(x, null).getPropertyValue(styleProp);
    return y;
}

function getBackgroundImages() {

    var elements = document.getElementsByTagName('*');
    var results = [], i = 0, bgIm;
    for (var i = 1; i < elements.length; i++) {

        bgIm = getStyle(elements[i], 'background-image');

        if (bgIm && bgIm !== 'none' && bgIm.indexOf("gradient") === -1) {

            bgIm = bgIm.replace(/url\((['"])?(.*?)\1\)/gi, '$2');

            var image = new Image();
            image.src = bgIm;

            var width = image.width,
                height = image.height;

            if (width < 50 || height < 50) { continue; }

            results.push({
                title: elements[i].alt || elements[i].title,
                width: width,
                height: height,
                src: bgIm,
            });
        }
    }
    return results;
}

chrome.runtime.sendMessage({
    action: "getSource",
    source: JSON.stringify(DOMtoString())
});

